#include <bits/stdc++.h>
#define int long long
#define pb push_back
using namespace std;

const int MAXN = 5e5;

vector <int> h, t, pref;
int beg[MAXN + 5], e[MAXN + 5];
int n, k;

int findlst(int bst, int time) {
    int lst;
    for (int j = bst; j <= n; j++) {
        if (pref[j] - pref[bst] > time) {
            lst = j;
            break;
        }
        if (e[bst] < j) {
            lst = j;
            break;
        }
        if (j == n) lst = j;
    }
    return lst;
}

bool ok(int time) {
    int k1 = k;
    int bst = 1, lst = 1;
    for (int i = 1; i <= n; i++) {
        if (pref[i] - pref[lst] > time) {
            k1--;
            for (int j = bst; j <= n; j++) {
                if (pref[j] - pref[bst] > time) {
                    lst = j;
                    break;
                }
                if (e[bst] < j) {
                    lst = j;
                    break;
                }
                if (j == n) lst = j;
            }
            i = lst; bst = lst;
        }
        if (h[i] >= h[bst]) bst = i;
        else if (findlst(i, time) >= findlst(bst, time)) bst = i;
    }
    if (lst != n) k1--;
    return (k1 >= 0 ? 1 : 0);
}

signed main() {
    cin >> n >> k;
    h.resize(n + 1); t.resize(n + 1); pref.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> h[i];
    for (int i = 1; i <= n - 1; i++) cin >> t[i];
    for (int i = 2; i <= n; i++) pref[i] = pref[i - 1] + t[i - 1];
    stack <int> st;
    for (int i = 1; i <= n; i++) {
        while (!st.empty() && h[st.top()] <= h[i]) {
            st.pop();
        }
        if (!st.empty()) beg[i] = st.top();
        else beg[i] = 1;
        st.push(i);
    }
    stack <int> st2;
    for (int i = n; i >= 1; i--) {
        while (!st2.empty() && h[st2.top()] <= h[i]) {
            st2.pop();
        }
        if (!st2.empty()) e[i] = st2.top();
        else e[i] = n;
        st2.push(i);
    }
    int l = 0, r = pref[n - 1], ans = -1;
    while (l <= r) {
        int m = (l + r) / 2;
        if (ok(m)) {
            r = m - 1;
            ans = m;
        }
        else l = m + 1;
    }
    cout << ans << endl;
}
