#include <bits/stdc++.h>

using namespace std;

int arr[128];
int prefix[128];
int sufix[128];

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    set<int>sums;
    map<int,int>map2;

    int n;

    cin >> n;

    for (int i = 0; i < n; i ++)
    {
        cin >> arr[i];
        sums.insert(arr[i]);
        map2[arr[i]]++;
    }

    prefix[0] = arr[0];
    sufix[n - 1] = arr[n - 1];

    for (int i = 1; i < n; i ++) {
        prefix[i] = prefix[i - 1] + arr[i];
    }


    for (int i = n - 2; i >= 0; i --) {
        sufix[i] = sufix[i + 1] + arr[i];
    }


    int currentsum = 0;
    int help1 = 0;
    int help2 = 0;
    for (int i = 0; i < n; i ++)
    {
        currentsum = 0;
        help1 = 0;
        help2 = 0;
        for (int j = i + 1; j < n; j ++)
        {
            currentsum = sufix[j] + prefix[i];
            help1 = sufix[j] + arr[i];
            help2 = prefix[i] + arr[j];

            map2[currentsum] ++;
            map2[help1] ++;
            map2[help2] ++;


            if(!sums.count(currentsum)) {
                sums.insert(currentsum);
            }else {
                currentsum = 0;
            }
            if(!sums.count(help1)) {
                sums.insert(help1);
            }
            if(!sums.count(help2)) {
                sums.insert(help2);
            }
        }
    }

    int u = 0;
    int v = 0;


    for(const int& h : sums) {
        cout << h << " ";
    }

    cout << endl << sums.size() << endl;

    for (auto c : map2) {
        cout << c.first << " " << c.second << endl;
    }

}
