#include <bits/stdc++.h>
using namespace std;

const long long MAXSUM = 100000;

long long sums[MAXSUM + 10], temp[MAXSUM + 10], a[71], n;

pair <long long, long long> dp[71][MAXSUM + 10];
bool v[71][MAXSUM + 10];

pair <long long, long long> sumdp(long long idx, long long sum) {
    if (sum == 0) return {0, 0};
    if (idx > n) return {-1, -1};
    if (v[idx][sum]) return dp[idx][sum];
    v[idx][sum] = 1;

    pair <long long, long long> current = sumdp(idx + 1, sum - a[idx]);
    if (current != pair <long long, long long>{-1, -1}) return dp[idx][sum] = pair <long long, long long>{a[idx], current.first + current.second};
    return dp[idx][sum] = sumdp(idx + 1, sum);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);
    sums[0] = 1;

    for (long long i = 1; i <= n; i++) {
        for (long long j = a[i]; j <= MAXSUM; j++) {
            temp[j] += sums[j - a[i]];
        }

        for (long long j = 1; j <= MAXSUM; j++) {
            sums[j] += temp[j];
            temp[j] = 0;
        }
    }

    long long br = 0;

    for (long long i = 1; i <= MAXSUM; i++) {
        br += sums[i] != 0;
    }

    cout << br << endl;

    pair <long long, long long> ans;

    for (long long i = 1; i <= MAXSUM; i++) {
        ans = max(ans, {sums[i], i});
    }

    long long idx = ans.second;
    cout << idx << ' ' << sums[idx] << endl;

    ans = sumdp(1, idx);
    int current_idx = 1;

    while (ans.first > 0) {
        cout << ans.first << ' ';
        ans = sumdp(upper_bound(a + 1, a + n + 1, ans.first) - a, ans.second);
    }

    return 0;

}
