#include<iostream>
using namespace std;

const long long MAXN=70+4;
const long long MAXSUM=70'000;

long long n;
long long a[MAXN];
long long dp[MAXSUM+10];
bool iz[MAXSUM+10];


void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


void input()
{
    cin>>n;
    for (long long i=0; i<n; i++) cin>>a[i];
}

void makeDP()
{
    dp[0]=1;
    iz[0]=1;

    for (long long i=0; i<n; i++)
    {
        for (long long sum=MAXSUM; sum-a[i]>=0; sum--)
        {
            if (iz[sum-a[i]])
            {
                iz[sum]=true;
                dp[sum]+=dp[sum-a[i]];
            }
        }
    }
}

void output1()
{
    long long ans=0;
    for (long long i=1; i<=MAXSUM; i++)
    {
        ans+=iz[i];
    }
    cout<<ans<<endl;
}

void output2()
{
    long long ans=0;
    long long mx=0;

    for (long long i=1; i<=MAXSUM; i++)
    {
        if (dp[i]>=ans)
        {
            mx=i;
            ans=dp[i];
        }
    }
    cout<<mx<<" "<<ans<<endl;
}
int main ()
{
    fastIO();
    input();
    makeDP();
    output1();
    output2();
    cout<<0<<endl;
}

