#include<bits/stdc++.h>
using namespace std;
#define endl '\n'
struct Hill
{
    int height;
    vector<int>visibleHills;
};
int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int N,k;
    cin>>N>>k;
    vector<Hill>hills(N);
    for(long long i=0; i<N; i++)
    {
        cin>>hills[i].height;
    }
    vector<int>travelTime(N-1);
    for(long long i=0; i<N-1; i++)
    {
        cin>>travelTime[i];
    }
    for(int i=0; i<N; i++)
    {
        for(int j=i+1; j<N; j++)
        {
            bool visible = true;
            for(long long k=i+1; k<j; k++)
            {
                if(hills[k].height>max(hills[i].height,hills[j].height))
                {
                    visible=false;
                    break;
                }
                if(visible)
                {
                    hills[i].visibleHills.push_back(j);
                    hills[j].visibleHills.push_back(i);
                }
            }
        }
    }
    vector<int>dp(N,numeric_limits<int>::max());
    vector<int>bestStation(N,-1);
    dp[0]=0;
    for(int stations=1; stations<k; stations++)
    {
        vector<int>newDp(N,numeric_limits<int>::max());
        vector<int>newBestStation(N,-1);
        for(int i=0; i<N; i++)
        {
            if(dp[i]==numeric_limits<int>::max())continue;
            for(int j=0; j<N; j++)
            {
                if(find(hills[i].visibleHills.begin(),hills[i].visibleHills.end(),j)!=hills[i].visibleHills.end())
                {
                    int travel=0;
                    for(int m=min(i,j); m<max(i,j); m++)
                    {
                        travel=travelTime[m];
                    }
                    int timeToReach=dp[i]+travel;
                    if(timeToReach<newDp[j])
                    {
                        newDp[j]=timeToReach;
                        newBestStation[j]=i;
                    }
                }
            }
        }
        dp=newDp;
        bestStation=newBestStation;
    }
    int minReactionTime=numeric_limits<int>::max();
    int bestHill=-1;
    for(long long i=0; i<N; i++)
    {
        if(dp[i]<minReactionTime)
        {
            minReactionTime=dp[i];
            bestHill=i;
        }
    }
    if(minReactionTime==numeric_limits<int>::max())
    {
        cout<<-1<<endl;
    }
    else
    {
        cout<<minReactionTime<<endl;
        vector<int>stations;
        for(long long i=0; i<k; i++)
        {
            stations.push_back(bestHill+1);
        }
        for(int station:stations)
        {
            cout<<station<<" ";
        }
        cout<<endl;
    }
    return 0;
}

